Module Flood

#Region "UnsafeFloodFill"
    ' Flood the area at this point.
    Public Sub UnsafeFloodFill(ByVal bm As Bitmap, ByVal x As Integer, ByVal y As Integer, ByVal new_color As Color)
        ' Get the old and new colors' components.
        Dim old_r As Byte = bm.GetPixel(x, y).R
        Dim old_g As Byte = bm.GetPixel(x, y).G
        Dim old_b As Byte = bm.GetPixel(x, y).B

        Dim new_r As Byte = new_color.R
        Dim new_g As Byte = new_color.G
        Dim new_b As Byte = new_color.B

        ' Start with the original point in the stack.
        Dim pts As New Stack(1000)
        pts.Push(New Point(x, y))
        bm.SetPixel(x, y, new_color)

        ' Make a BitmapBytesARGB32 object.
        Dim bm_bytes As New BitmapBytesARGB32(bm)

        ' Lock the bitmap.
        bm_bytes.LockBitmap()

        ' While the stack is not empty, process a point.
        Dim pix As Integer
        Do While pts.Count > 0
            Dim pt As Point = DirectCast(pts.Pop(), Point)
            If pt.X > 0 Then UnsafeCheckPoint(bm_bytes, pts, pt.X - 1, pt.Y, old_r, old_g, old_b, new_r, new_g, new_b)
            If pt.Y > 0 Then UnsafeCheckPoint(bm_bytes, pts, pt.X, pt.Y - 1, old_r, old_g, old_b, new_r, new_g, new_b)
            If pt.X < bm.Width - 1 Then UnsafeCheckPoint(bm_bytes, pts, pt.X + 1, pt.Y, old_r, old_g, old_b, new_r, new_g, new_b)
            If pt.Y < bm.Height - 1 Then UnsafeCheckPoint(bm_bytes, pts, pt.X, pt.Y + 1, old_r, old_g, old_b, new_r, new_g, new_b)
        Loop

        ' Unlock the bitmap.
        bm_bytes.UnlockBitmap()
    End Sub

    ' See if this point should be added to the stack.
    Private Sub UnsafeCheckPoint(ByVal bm_bytes As BitmapBytesARGB32, ByVal pts As Stack, ByVal x As Integer, ByVal y As Integer, ByVal old_r As Byte, ByVal old_g As Byte, ByVal old_b As Byte, ByVal new_r As Byte, ByVal new_g As Byte, ByVal new_b As Byte)
        Dim pix As Integer = y * bm_bytes.RowSizeBytes + x * bm_bytes.PixelSizeBytes
        Dim b As Byte = bm_bytes.ImageBytes(pix)
        Dim g As Byte = bm_bytes.ImageBytes(pix + 1)
        Dim r As Byte = bm_bytes.ImageBytes(pix + 2)

        If (r = old_r) AndAlso (g = old_g) AndAlso (b = old_b) Then
            pts.Push(New Point(x, y))
            bm_bytes.ImageBytes(pix) = new_b
            bm_bytes.ImageBytes(pix + 1) = new_g
            bm_bytes.ImageBytes(pix + 2) = new_r
        End If
    End Sub
#End Region ' UnsafeFloodFill

#Region "SafeFloodFill"
    ' Flood fill the point.
    Public Sub SafeFloodFill(ByVal bm As Bitmap, ByVal x As Integer, ByVal y As Integer, ByVal new_color As Color)
        ' Get the old and new colors.
        Dim old_color As Color = bm.GetPixel(x, y)

        ' Start with the original point in the stack.
        Dim pts As New Stack(1000)
        pts.Push(New Point(x, y))
        bm.SetPixel(x, y, new_color)

        ' While the stack is not empty, process a point.
        Do While pts.Count > 0
            Dim pt As Point = DirectCast(pts.Pop(), Point)
            If pt.X > 0 Then SafeCheckPoint(bm, pts, pt.X - 1, pt.Y, old_color, new_color)
            If pt.Y > 0 Then SafeCheckPoint(bm, pts, pt.X, pt.Y - 1, old_color, new_color)
            If pt.X < bm.Width - 1 Then SafeCheckPoint(bm, pts, pt.X + 1, pt.Y, old_color, new_color)
            If pt.Y < bm.Height - 1 Then SafeCheckPoint(bm, pts, pt.X, pt.Y + 1, old_color, new_color)
        Loop
    End Sub

    ' See if this point should be added to the stack.
    Private Sub SafeCheckPoint(ByVal bm As Bitmap, ByVal pts As Stack, ByVal x As Integer, ByVal y As Integer, ByVal old_color As Color, ByVal new_color As Color)
        Dim clr As Color = bm.GetPixel(x, y)
        If clr.Equals(old_color) Then
            pts.Push(New Point(x, y))
            bm.SetPixel(x, y, new_color)
        End If
    End Sub
#End Region ' SafeFloodFill

End Module
