Imports System.Math
Imports System.Drawing.Imaging
imports System.Runtime.InteropServices

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(472, 381)
        Me.Name = "Form1"
        Me.Text = "Form1"

    End Sub

#End Region

    ' See Eric W. Weisstein. "Truchet Tiling."
    ' From MathWorld--A Wolfram Web Resource. http://mathworld.wolfram.com/TruchetTiling.html

    Private m_Random As New Random
    Private m_Bitmap As Bitmap

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        e.Graphics.DrawImage(m_Bitmap, 0, 0)
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        m_Bitmap = MakeBitmap()
        Me.Invalidate()
    End Sub

    ' Make a bitmap displaying the image.
    Private Function MakeBitmap() As Bitmap
        Const RADIUS As Single = 12
        Const WID As Single = 2 * RADIUS
        Dim max_r As Integer
        Dim max_c As Integer
        Dim X As Single
        Dim Y As Single

        Dim bm As New Bitmap(Me.ClientSize.Width, Me.ClientSize.Height)
        Dim gr As Graphics = Graphics.FromImage(bm)

        gr.Clear(Me.BackColor)
        max_c = ClientRectangle.Width \ WID + 1
        max_r = ClientRectangle.Height \ WID + 1
        Y = 0
        For r As Integer = 0 To max_r
            X = 0
            For c As Integer = 0 To max_c
                ' Note that angles are in clockwise degrees.
                If m_Random.Next(0, 2) = 0 Then
                    gr.DrawArc(Pens.Black, X - RADIUS, Y - RADIUS, WID, WID, 0, 90)
                    gr.DrawArc(Pens.Black, X + RADIUS, Y + RADIUS, WID, WID, 180, 90)
                Else
                    gr.DrawArc(Pens.Black, X - RADIUS, Y + RADIUS, WID, WID, 270, 90)
                    gr.DrawArc(Pens.Black, X + RADIUS, Y - RADIUS, WID, WID, 90, 90)
                End If
                X = X + WID
            Next c
            Y = Y + WID
        Next r

        gr.DrawRectangle(Pens.Black, 0, 0, Me.ClientSize.Width, Me.ClientSize.Height)

        gr.Dispose()
        Return bm
    End Function

    Private Sub Form1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        ' Pick a random new color.
        Dim rnd As New Random
        Dim old_color As Color = m_Bitmap.GetPixel(e.X, e.Y)
        Dim new_color As Color
        Do
            Dim qb_clr As Integer = QBColor(rnd.Next(1, 16))
            new_color = Color.FromArgb(qb_clr Or &HFF000000)
        Loop Until Not (new_color.Equals(old_color))

        ' Flood.
        Dim start_time As Date = Now
        If e.Button = MouseButtons.Left Then
            UnsafeFloodFill(m_Bitmap, e.X, e.Y, new_color)
        Else
            SafeFloodFill(m_Bitmap, e.X, e.Y, new_color)
        End If
        Dim elapsed_time As TimeSpan = Now.Subtract(start_time)
        Debug.WriteLine(elapsed_time.TotalSeconds.ToString("0.00"))

        ' Redraw.
        Me.Invalidate()
    End Sub
End Class
